//--------------------------------------------------------------------------
#include <EEPROM.h>
#include <WString.h>
#define byte uint8_t

unsigned int addr = 0;
String str[20];

long myID = 1000;

//----------------------------------------------------------------------
int scan[3] = {0, 0, 0};
int count[3];
unsigned int BUFFER[3][100][16][2];
//----------------------------------------------------------------------
#include <SD.h>
#include <SPI.h>
File myFile;
const int chipSelect = 4;   // Wiz820+SD board: pin 4
//----------------------------------------------------------------------
#include <Ethernet.h>
byte mac[] = {0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED};
IPAddress ip(192, 168, 1, 157);
EthernetServer server(80);

#include <Arduino.h>
#include <U8g2lib.h>
#ifdef U8X8_HAVE_HW_I2C
#include <Wire.h>
#endif

U8G2_SH1106_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE); //My SH1106  (also works on SSD1306)
//U8G2_SSD1306_128X64_NONAME_F_SW_I2C u8g2(U8G2_R0, /* clock=*/ SCL, /* data=*/ SDA, /* reset=*/ U8X8_PIN_NONE);   //SSD1306
//--------------------------------------------------------------------------
void createBuffer()
{
  scan[0] = 10;
  scan[1] = 20;
  scan[2] = 30;

  for (int SN = 0; SN < 3; SN++)          
  {
    for (int j = 1; j <= scan[SN] - 1; j++)
    {
      for (int k = 0; k < 16; k++)
      {
        BUFFER[SN][j][k][0] = 100;
        BUFFER[SN][j][k][1] = 200;
      }
    }
  }
}



void setup()
{
  //------------------------------------------------------------
  Serial.begin(115200);
  createBuffer();
  delay(2000);
  Serial.println("Starting ...");

  //------------------------------------------------------------
  //https://www.pjrc.com/store/wiz820_sd_adaptor.html#init
  //https://github.com/PaulStoffregen/Ethernet
  //https://blog.startingelectronics.com/disabling-the-ethernet-chip-and-sd-card-on-an-arduino-ethernet-shield/

  pinMode(9, OUTPUT);
  digitalWrite(9, LOW);    // begin reset the WIZ820io

  pinMode(10, OUTPUT);
  digitalWrite(10, HIGH);  // de-select WIZ820io

  pinMode(4, OUTPUT);
  digitalWrite(4, HIGH);   // de-select the SD Card

  digitalWrite(9, HIGH);   // end reset pulse

  //------------------------------------------------------------
  Serial.print("Initializing SD card...");
  if (!SD.begin(chipSelect)) {
    Serial.println("initialization failed!");
    //return;
  }
  Serial.println("initialization done.");
  write2SD();
  readSD();
  //------------------------------------------------------------
  u8g2.begin();
  u8g2_prepare();
  String myVal = "jimmie";
  showU8G2(11, 12, myVal);
  delay(2000);
  //------------------------------------------------------------
  myVal = "Sensors";
  showU8G2(77, 77, myVal);
  delay(2000);
  //------------------------------------------------------------
  Ethernet.begin(mac, ip);
  if (Ethernet.hardwareStatus() == EthernetNoHardware) {
    Serial.println("Ethernet shield was not found.  Sorry, can't run without hardware. :(");
    while (true) {
      delay(1); // do nothing, no point running without Ethernet hardware
    }
  }
  if (Ethernet.linkStatus() == LinkOFF) {
    //Serial.println("Ethernet cable is not connected.");   //not working?
  }
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());

  //------------------------------------------------------------

  Serial.println("------------->>>>  Starting");
}


void loop()
{
  for (int i = 0; i <= 255; i++) {
    writeAllData();
    myID ++;
    delay(1000);
  }
}

void u8g2_prepare(void) {
  u8g2.setFont(u8g2_font_6x10_tf);
  u8g2.setFontRefHeightExtendedText();
  u8g2.setDrawColor(1);
  u8g2.setFontPosTop();
  u8g2.setFontDirection(0);
}

void showU8G2(int intVal1, int intVal2, String &strVal)
{
  u8g2.clearBuffer();

  u8g2.setCursor(0, 0);
  u8g2.print(intVal1);

  u8g2.setCursor(0, 25);
  u8g2.print(intVal2);

  u8g2.setCursor(0, 50);
  u8g2.print(strVal);

  u8g2.sendBuffer();
}
